#line 1031 "nw/geoma.nw"
    #include <iostream>
    #include <stdexcept>
    #include <complex>
    #include "geoma.h"
    #include "geomaData.h"

    
#line 638 "nw/geoma.nw"
int
main( void )
{
    nklein::GeometricAlgebra< int, 2, 1 > a;
    nklein::GeometricAlgebra< int, 2, 1 > b;
    nklein::GeometricAlgebra< int, 2, 1 > c(false);
    nklein::GeometricAlgebra< int, 3 > d;
    nklein::GeometricAlgebra< double, 3 > e;
    nklein::GeometricAlgebra< std::complex< double >, 3 > f;

    a[0] = 1;
    a[1] = 1;
    a[3] = 1;
    a[7] = 1;

    b[1] = 1;
    b[2] = 1;
    b[4] = 1;

    c = a;
    std::cout << "a = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 659 "nw/geoma.nw"
                      ;

    c = b;
    std::cout << "b = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 663 "nw/geoma.nw"
                      ;

    c = 2 * a - b;
    std::cout << "2*a - b = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 667 "nw/geoma.nw"
                      ;

    c = a.GradeInvolution();
    std::cout << "\\hat{a} = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 671 "nw/geoma.nw"
                      ;

    c = a.Reversion();
    std::cout << "\\tilde{a} = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 675 "nw/geoma.nw"
                      ;

    c = a.Conjugation();
    std::cout << "\\bar{a} = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 679 "nw/geoma.nw"
                      ;

    c = b*b;
    std::cout << "b*b = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 683 "nw/geoma.nw"
                      ;

    c = a*b;
    std::cout << "a*b = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 687 "nw/geoma.nw"
                      ;

    c = b*a;
    std::cout << "b*a = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 691 "nw/geoma.nw"
                      ;

    c = a^b;
    std::cout << "a^b = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 695 "nw/geoma.nw"
                      ;

    c = b^a;
    std::cout << "b^a = " <<
	
#line 709 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< std::endl
#line 699 "nw/geoma.nw"
                      ;

    return 0;
}
